# This is the main file of the project and it is from here that you are setting all variables from an UI
import ast

import tweetsRunner
import bitlyRunner
import UpdateClicksOld
import htmlToText
import json
import bitlydatahandler
import naiveBayesPipeline
import Queue as NormalQueue
import time
from random import randint
from multiprocessing import Process, Pool, Manager
import re
import os
import excelWriter


def b(tweetsPath, lock, hourordaily, time_for_filename):
    print("in b")
    lock.acquire()
    res = bitlyRunner.run(tweetsPath, hourordaily, time_for_filename)
    lock.release()
    print "b has been released"
    return res

def u(q, sleep, turns, lock):
    turnDict = {}
    updatingQueue = NormalQueue.PriorityQueue()
    timeOfUpdateQueue = NormalQueue.PriorityQueue()
    timeOfNextUpdate = 0
    run = True
    rerun = False
    updatingQueuePath =("./data/resumeoncrash/updatingqueue.txt")
    turnDictPath = "./data/resumeoncrash/turndict.txt"
    timeOfLatestUpdatePath = ("./data/resumeoncrash/timeoflatestupdate.txt")
    print "Starting update process"
    while run:
        print("in run")
        if(rerun):

            timeOfLastUpdateFile = open(timeOfLatestUpdatePath, "r")
            lastUpdateBeforeCrashTime = float(timeOfLastUpdateFile.read())
            timeOfLastUpdateFile.close()

            updatingQueueFile = open(updatingQueuePath, 'r')
            listUpdatingQueueBeforeCrash = ast.literal_eval(updatingQueueFile.read())
            updatingQueueFile.close()

            turnDictFile = open(turnDictPath, 'r')
            turnDict = ast.literal_eval(turnDictFile.read())
            turnDictFile.close()
            downTime = time.time() - lastUpdateBeforeCrashTime

            for item in listUpdatingQueueBeforeCrash:
                timeForUpdate = float(item[0])
                path = item[1]

                updatingQueue.put(((timeForUpdate + downTime), path))
                timeOfUpdateQueue.put(timeForUpdate + downTime)
            timeOfNextUpdate=timeOfUpdateQueue.get()
            print "The next update is in: %.2f" % (timeOfNextUpdate - time.time())
            print("rerun method completed")
            rerun = False


        # timeOfNextUpdate never becomes not null.
        # print "The time of the next update is: %.2f" % timeOfNextUpdate
        if (timeOfNextUpdate != 0):
            print("time was not 0")
            # print "The next update is in: %.2f" % (timeOfNextUpdate - time.time())
            if time.time() >= timeOfNextUpdate:
                path = updatingQueue.get()[1]
                startGetting = time.time()
                startBitly = time.time()
                lock.acquire()
                res = bitlydatahandler.updateClicks(path)
                lock.release()
                turnPath= path[7:-4]
                if(turnPath not in turnDict.keys()):
                    turnDict[turnPath]=1
                else:
                    turnDict[turnPath]=turnDict[turnPath] + 1
                for item in turnDict:
                    print("path: " + item + " turn: " + str(turnDict[item]))

                #create list for saving updatingQueue if program freezes
                listupdatingqueue= list(updatingQueue.queue)

                #create .txt file for the timestamp last update was performed
                timeOfLastUpdateFile = open(timeOfLatestUpdatePath, "w+")
                lastUpdate = time.time()
                timeOfLastUpdateFile.write(str(lastUpdate))
                timeOfLastUpdateFile.close()

                #saves the updatingqueue to a txt
                updatingQueueFile = open(updatingQueuePath, "w+")
                updatingQueueFile.write(str(listupdatingqueue))
                updatingQueueFile.close()

                #saves the turnDict to .txt
                turnDictFile = open(turnDictPath, 'w+')
                turnDictFile.write(str(turnDict))
                turnDictFile.close()

                if turnDict[turnPath] == 6 and turnPath.endswith("1h"): #6
                    print("Just split the data into 1h and 24h")
                    hourlydata = ''
                    dailydata = ''
                    originalPath = open(path, "r")
                    content = originalPath.readlines()
                    originalPath.close()

                    for line in res:
                        for con in content:
                            if (int(line['global_clicks'] < 450) and int(line['random']) == 0):
                                if (str(line['short_url']) in con):
                                    con=con.replace("'is24h': 0","'is24h': 1")

                                    dailydata = dailydata + con
                            else:
                                if (str(line['short_url']) in con):
                                    if(int(line['random'])== 1 and int(line['global_clicks'] < 450)):
                                        con = con.replace("'is24h': 0", "'is24h': 1")
                                    hourlydata = hourlydata + con
                    print("dailydata: " + dailydata)
                    print("hourlydata: " + hourlydata)

                    hourlywriter = open(path, "w")
                    hourlywriter.write(hourlydata)
                    hourlywriter.close()
                    dailypath = path[:-7] + "24h.txt"
                    print("dailypath: " + dailypath)

                    o = open(dailypath, "w")
                    o.write(dailydata)
                    o.close()
                    dailydata = ''
                    hourlydata = ''
                    content = []


                time_for_filename = time.strftime("%Y-%m-%d_%H%M%S")
                # print "u has been released, %.2f seconds after requesting lock" % (time.time() - startGetting)
                updatePath = path[:(len(path) - 4)] + "_(" + time_for_filename + ").txt"
                f = open(updatePath, "w")
                f.write(str(res))
                f.close()
                print "bitlys updated in %.2f seconds" % (time.time() - startBitly)
                print "Done with all IO after %.2f seconds, for now." % (time.time() - startGetting)
                # print "Is the time queue empty: " , timeOfUpdateQueue.empty()
                # print "Is the updating queue empty: " , updatingQueue.empty()
                if timeOfUpdateQueue.empty() is False:
                    print("timeofupdatequeue is not empty")
                    timeOfNextUpdate = timeOfUpdateQueue.get()
                    print "Next update is in %.2f seconds." % (timeOfNextUpdate - time.time())
                else:
                    #Testa.mail("Done updating")
                    run = False
                    print "Done updating"
                    return "DONE"
            else:
                time.sleep(1)

        else:
            time.sleep(2)
        print("sleep")
        print "Is the queue empty: " , q.empty()
        if q.empty() is False:
            newsPath = q.get()
            print(str(newsPath))
            if (newsPath.endswith("1h.txt")):
                timeConstant = 1
                turns=60 #60
            else:
                timeConstant = 12 #12
                turns=5 #5

            print "Turns to save:", turns
            t = time.time()
            i = 1
            while i <= turns:
                print("add to updating queue")
                updatingQueue.put(((t + (sleep *timeConstant * i)), newsPath))
                print("add to timeofupdatequeue")
                timeOfUpdateQueue.put(t + (sleep * timeConstant * i))
                if timeOfNextUpdate == 0:
                    timeOfNextUpdate = timeOfUpdateQueue.get()
                    print "First update time added. It is in %.2f seconds." % (timeOfNextUpdate - time.time())
                i = i + 1
    return "DONE"

# @profile
def runfunc(sleeplength, timeout, runs, runBitly, runHtmlExtractor, runNaiveBayes, saveClicks):
    print("runfunc")
    manager = Manager()
    q = manager.Queue()
    lock = manager.Lock()
    p = Process(target=u, args=(q, sleeplength, turns, lock))
    p.start()
    print p.pid

    pool = Pool(processes=1, maxtasksperchild=2)
    i = 0
    path = './data/'
    while i < runs:
        tweetsPath = tweetsRunner.collectTweets(timeout)
        print(tweetsPath)

        i = i + 1
        if runBitly == "y":
            print "Running bitlys"
            time_for_filename = time.strftime("%Y-%m-%d_%H%M%S")
            pool.apply_async(b, (tweetsPath,lock,True, time_for_filename), callback=q.put)

            pool.apply_async(b, (tweetsPath,lock,False, time_for_filename), callback=q.put)

            print("Files created and put on queue")

    pool.close()
    pool.join()
    if sleeplength > 0:
        p.join()
        print "P should have joined now"
        print p.is_alive()
        if p.is_alive():
            p.terminate()

    if runHtmlExtractor == "y":
        print "Running html"
        htmlToText.run()

    if runNaiveBayes == "y":
        print "Running Bayes"
        naiveBayesPipeline.run()

    if saveClicks == "y":
        print "Running updates"
        excelWriter.main()

    print "FINISHED"


if (__name__ == '__main__'):

    #If different gathering times, intervals etc, there are more settings on line 104 .167.

    sleeplength = 7200 #7200# int(raw_input("How often would you like to update clicks, answer in seconds "))
    timeout = 1200  # input("In seconds, for how long would you like to collect tweets? This one is the 10-minute we gather tweets ", )
    turns = 60  # int(raw_input("How many times would you like to update? used to be 84"))
    runs = 81 #72  # input("For how many runs would you like to collect tweets?  used to be 288", )

    # sleeplength = 10 #7200# int(raw_input("How often would you like to update clicks, answer in seconds "))
    # timeout = 10  # input("In seconds, for how long would you like to collect tweets? This one is the 10-minute we gather tweets ", )
    # turns = 60  # int(raw_input("How many times would you like to update? used to be 84"))
    # runs = 2 #72  # input("For how many runs would you like to collect tweets?  used to be 288", )

    # sleeplength = 10 #7200# int(raw_input("How often would you like to update clicks, answer in seconds "))
    # timeout = 30  # input("In seconds, for how long would you like to collect tweets? This one is the 10-minute we gather tweets ", )
    # turns = 4  # int(raw_input("How many times would you like to update? used to be 84"))
    # runs = 2 #72  # input("For how many runs would you like to collect tweets?  used to be 288", )

    # sleeplength = 10  # 7200# int(raw_input("How often would you like to update clicks, answer in seconds "))
    # timeout = 300  # input("In seconds, for how long would you like to collect tweets? This one is the 10-minute we gather tweets ", )
    # turns = 4  # int(raw_input("How many times would you like to update? used to be 84"))
    # runs = 3 #72  # input("For how many runs would you like to collect tweets?  used to be 288", )

    runBitly = "y"  # raw_input("Would you like to extract bitly info too? (y/n)")
    runHtmlExtractor = "y"  # raw_input("Would you like to extract articles from identified links? (y/n)")
    runNaiveBayes = "y"  # raw_input("Would you like to classify extracted articles? (y/n)")
    saveClicks = "y"  # raw_input("Would you like to save clicks to excelfile? (y/n)")

    #FIRST RUN
    # SATT RERUN FALSE
    open('./data/seenShortURLs.txt', 'w').close()
    open('./data/expanded.txt', 'w').close()
    open('./data/runme.txt', 'w').close()
    open('./data/links/UnknownArticlesToBeExtracted.txt', 'w').close()
    open('./data/links/articleURLAndTitle.txt', 'w').close()
    open('./data/news/classifications.txt', 'w').close()
    open('./data/resumeoncrash/timeoflatestupdate.txt', 'w+').close()
    open('./data/resumeoncrash/timeofnextupdate.txt', 'w+').close()
    open('./data/resumeoncrash/turndict.txt', 'w+').close()
    open('./data/resumeoncrash/updatingqueue.txt', 'w+').close()

    # ##RERUN
    # If rerun-restart, put rerun true. line 34
    # What is does is loads the queue it had to update from file and restarts the gathering from there
    # Decrease runs to the ones left until reached total runs
    # open('./data/seenShortURLs.txt', 'w').close()
    # open('./data/expanded.txt', 'w').close()
    # open('./data/runme.txt', 'w').close()
    # open('./data/links/UnknownArticlesToBeExtracted.txt', 'w').close()
    # open('./data/links/articleURLAndTitle.txt', 'w').close()
    # open('./data/news/classifications.txt', 'w').close()
    # Erase contents in some .txt

    runfunc(sleeplength, timeout, runs, runBitly, runHtmlExtractor, runNaiveBayes, saveClicks)