# -*- coding: cp1252 -*-
# Communicates with bitly.com to expand short URL's
# Send request to bitly API and write response to file.
# shortUrls is an array of up to 15 short URL's (bitly.com API max limit)
def expandShortUrl(shortUrls, c):
    # File to write to
    path = './data/'

    response = None
    try:
        o = open(path + 'expanded.txt', 'a+')
        response = c.expand(shortUrl=shortUrls)
        # print("Lnkar extraherad")
        o.write((str(response).encode('utf-8')) + '\n')
        o.close()
    except:
        pass
    return response;


def getRefs(link, c):
    refs = None
    try:
        refs = c.link_referrers_by_domain(link)
    except:
        print('')
    return refs;


def getLinkCountries(link, c):
    countries = None
    try:
        countries = c.link_countries(link)
    except:
        print('')
    return countries;


def getURLClicks(globalHash, c):
    URLclicks = None
    try:
        URLclicks = c.clicks(globalHash)
    except:
        print('Unable to retrieve clicks')
    return URLclicks;

# Dummy main function, just for testing a bitly URL	
# if __name__ == '__main__':
#	shortUrls = []
#	shortUrls.append('http://bit.ly/28Zo8vQ')
#	expandShortUrl(shortUrls)
#	getURLClicks('28ZYUgL')
#	getLinkCountries('http://bit.ly/28Zo8vQ')
#	getRefs('http://bit.ly/28Zo8vQ')
